<?php

/**
 * index.php: Provides a summary of the latest releases of CookingSpecial, and links to instances of the latest and stable versions of CookingSpecial.
 */

$release_dir = './releases/';
$releases = glob($release_dir . '*.tar.gz');

function m3($filename) { return filemtime($filename); };
$times = array_map("m3", $releases);

function m4($filename) { $time = filemtime($filename); return strftime('%a %b-%e-%Y at %I:%M%P', $time); };
$dates = array_map("m4", $releases);

$assoc = array();
for ($i = 0; $i < count($releases); $i++) {
	$release = $releases[$i];
	$date = $dates[$i];
	$timestamp = (int)$times[$i];
	$assoc[$timestamp] = array(
		'filename' => $release,
		'date' => $date,
		'timestamp' => $timestamp,
	);
}

krsort($assoc);

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<title>CookingSpecial Releases</title>
</head>

<body>
	<h1>CookingSpecial <a href="http://cubist.cs.washington.edu/projects/09sp/cse403/cookingspecial/">Release Page</a></h1>
	<p>This page contains daily builds, and the latest releases of the CookingSpecial project.</p>
	<p><i>Click on Latest Stable to see the latest stable version of a working CookingSpecial website</i></p>
	<p><i>Click on the first Release link to download the latest stable release of CookingSpecial source code.</i></p>
	<h3>Daily Builds (<i>Published Website Releases</i>)</h3>
	<div>
		<strong>Latest Stable (Updated After Each Release)</strong>:
		<a href="http://cubist.cs.washington.edu/projects/09sp/cse403/cookingspecial/stable/website/www/">Link</a>
	</div>

	<div>
		<strong>Latest Revision (Updated Daily)</strong>:
		<a href="http://cubist.cs.washington.edu/projects/09sp/cse403/cookingspecial/daily/website/www/">Link</a>
	</div>

	<h3>Latest Releases (<i>Source Code for Developers</i>)</h3>
	<?php foreach($assoc as $val) { ?>
		<div><strong><?php echo $val['date']; ?></strong>:  <a href="<?php echo $val['filename'] ?>"><?php echo $val['filename'] ?></a></div>
	<?php } ?>
</body>
</html>
