#!/usr/local/bin/perl

use strict;
use warnings;

use qfc_parser;
use db_specials;

if (scalar(@ARGV) == 0) {
	GetZipCodeAndInsertSpecialsIntoDb();
}
elsif ($ARGV[0] == "test") {
	RunTests();
}

sub GetZipCodeAndInsertSpecialsIntoDb() {

    my $storeName = "QFC";
    my @zipCodeArray = GetStoreZipCodes($storeName);
    
	if (scalar(@zipCodeArray) == 0) {
		print "No zip codes to test for $storeName.\n";
	}
	
    for my $zipCode (@zipCodeArray) {
		print "Getting speicals for zipcode $zipCode\n";
		
		my $allSpecialsRef = InsertSpecialsForZipcode($zipCode);
		InsertSpecialsIntoDb($storeName,
					 $zipCode,			 
					 $allSpecialsRef);
    }
}

sub RunTests {
	# Assuming QFC is in the database
	my $storeName = "QFC";
	my @specialsReferences = ();
	
	print STDERR "Can get the zip codes: ";
	
    my @zipCodeArray = GetStoreZipCodes($storeName);
    
	if (scalar(@zipCodeArray) == 0) {
		die("Failed... : No zip code for QFC exiting...\n");		
	}
	
	eval {
		for my $zipCode (@zipCodeArray) {
			my $allSpecialsRef = QFC_GetSpecialsForZipCode($zipCode);	
			push(@specialsReferences, $allSpecialsRef);
		}
	};
	
	if ($@) {
		die("Failed... : QFC parser has problems exiting...\n");
	}
	
	if (scalar(@specialsReferences) == 0) {
		print STDERR "Failed, no  special references retrieved\n";
	}
	
	for my $specialsRef (@specialsReferences) {
		my $i, my $aRow;
		for ($i = 0, $aRow = $specialsRef->[$i]; defined($aRow); $i++, $aRow = $specialsRef->[$i]) {
			if ($aRow->[0] && $aRow->[1]) {
				print STDERR "Failed, some of the specials are not valid\n";
				die("Done with all the tests\n");
			}
		}
	}
	
}
	
	